
#ifndef align_cost_hh
#define align_cost_hh

#include "ScoringMatrix.hh"
#include <string>
#include <sstream>
#include <iostream>
#include <fstream>
#include <stdexcept>

static ScoringMatrix scoring;
static bool initialized = false;

inline void initializeScoring(){
	std::cout << "Reading scoring from scoring.txt\n";
	std::fstream input("scoring.txt");
	if(!input){
		std::cerr << "scoring.txt could not be opened!\n";
		throw std::runtime_error("scoring could not be opened!");

	}
	input >> scoring;
	input.close();
	//std::cout << "Read the following scoring:\n" << scoring;
	initialized = true;
}

inline double del_cost(char left){
	if(!initialized){
		initializeScoring();
	}
	return get(scoring, left,'-');
}

inline double skip_del_cost(char left){
	if(!initialized){
		initializeScoring();
	}
	return get(scoring, left,'_');
}

inline double ins_cost(char right){
	if(!initialized){
		initializeScoring();
	}
	return get(scoring, '-',right);
}

inline double skip_ins_cost(char right){
	if(!initialized){
		initializeScoring();
	}
	return get(scoring, '_',right);
}

inline double rep_cost(char left, char right){
	if(!initialized){
		initializeScoring();
	}
	return get(scoring, left,right);
}

inline ScoringMatrix getInitial(){
	if(!initialized){
		initializeScoring();
	}
	//copy
	ScoringMatrix out = scoring;
	//set everything to initial
	for(unsigned int i = 0; i < out.size(); i++){
		for(unsigned int j = 0; j < out.size(); j++){
			out.set(i,j,0);
		}
	}
	
	return out;
}

#endif
