
#ifndef soft_derivative_hh
#define soft_derivative_hh

struct soft_derivative {
  double softmin;
  ScoringMatrix deriv;
  bool empty_;
  soft_derivative() : empty_(false) {}
bool operator>(const soft_derivative& other) const { return softmin > other.softmin; }
bool operator<(const soft_derivative& other) const { return softmin < other.softmin; }
bool operator==(const soft_derivative& other) const { return softmin == other.softmin; }
template <typename T> bool operator>(const T &other) const {return softmin > other; }
template <typename T> bool operator<(const T &other) const {return softmin < other; }
template <typename T> bool operator==(const T &other) const {return softmin == other; }


soft_derivative(int i) : softmin(i), empty_(false) {}
soft_derivative operator+(const soft_derivative &other) const
{
assert(!empty_); assert(!other.empty_);
return soft_derivative(softmin + other.softmin);
}
soft_derivative operator-(const soft_derivative &other) const
{
assert(!empty_);
if (other.empty_) return soft_derivative(softmin);
return soft_derivative(softmin - other.softmin);
}
bool operator<=(const soft_derivative& other) const {
assert(!empty_); assert(!other.empty_);
return softmin <= other.softmin;
}

};

inline std::ostream &operator<<(std::ostream &o, const soft_derivative &tuple) {
  o << tuple.softmin   << "\n" << tuple.deriv ;
  return o;
}

inline void empty(soft_derivative &e) {e.empty_ = true; }
inline bool isEmpty(const soft_derivative &e) { return e.empty_; }

#endif
