function [ num_algos,  algos, algo_names, lineSpecs, ranges ] = setupAlgorithms(alignSpec)


% javaaddpath TCSAlignmentToolbox-1.4.jar;
import de.unibi.citec.tcs.alignment.sequence.*;
import de.unibi.citec.tcs.alignment.*;
import de.unibi.citec.tcs.alignment.comparators.*;
import de.unibi.citec.tcs.alignment.wrappers.RandomSequenceGenerator;

% construct an array of all algorithms.

num_algos = 11;

algos = javaArray('de.unibi.citec.tcs.alignment.AlignmentAlgorithm',num_algos);
% strict global sequence alignment.
algos(1) = StrictAlignmentScoreAlgorithm(alignSpec);
algos(2) = StrictAlignmentFullAlgorithm(alignSpec);
% algos(3) = StrictAllOptimalAlgorithm(alignSpec);
% algos(4) = StrictKPathAlgorithm(alignSpec);
% soft global sequence alignment.
algos(3) = SoftAlignmentScoreAlgorithm(alignSpec);
algos(4) = SoftAlignmentFullAlgorithm(alignSpec);
algos(5) = SoftAlignmentSamplingAlgorithm(alignSpec);
% strict dynamic time warping.
algos(6) = StrictDTWScoreAlgorithm(alignSpec);
algos(7) = StrictDTWFullAlgorithm(alignSpec);
% strict local sequence alignment.
algos(8) = StrictLocalAlignmentScoreAlgorithm(alignSpec);
algos(9) = StrictLocalAlignmentFullAlgorithm(alignSpec);
% soft local sequence alignment
algos(10) = SoftLocalAlignmentScoreAlgorithm(alignSpec);
algos(11) = SoftLocalAlignmentFullAlgorithm(alignSpec);

%     'strict global alignment all optimal paths',...
%     'strict global alignment k-Path',...
algo_names = {'strict global alignment score',...
    'strict global alignment single path',...
    'soft global alignment score',...
    'soft global alignment full matrix',...
    'soft global alignment path sampling',...
    'strict dynamic time warping (DTW) score',...
    'strict dynamic time warping (DTW) path',...
    'strict local alignment score',...
    'strict local alignment path',...
    'soft local alignment score',...
    'soft local alignment full matrix'};

lineSpecs = {'r-','b-','r--','b--','k--',...
    'r-','b-',...
    'r-','b-','r--','b--'};

ranges = cell(3);
ranges{1} = 1:5;
ranges{2} = 6:7;
ranges{3} = 8:11;

end

